% ex1.m
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Problema di Dirichlet su quadrato unitario
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% h =k= stepsize in x ed y
% M numero di passi di Gauss-Seidel
% (n+2)^2 numero punti della mesh
M=20;
n=18;
h=1/(n+1);

% il numero di mesh point xi in [0,1]e' n+2
x=0:h:1;
y=0:h:1;
v=zeros(n+2,n+2);

% Calcolo valori di frontiera
v(:,1)=feval(@gfun,x,zeros(1,n+2));
v(:,n+2)=feval(@gfun,x,ones(1,n+2));
v(1,:)=feval(@gfun,zeros(1,n+2),y);
v(n+2,:)=feval(@gfun,ones(1,n+2),y);

% Risoluzione sistema lineare mediante Gauss-Seidel
for k=1:M 
   for j=2:n+1
	   for i=2:n+1
	   v(i,j)=(v(i-1,j)+v(i+1,j)+v(i,j-1)+v(i,j+1))/4;
		end
	end
end

surf(x,y,v,'FaceColor',[0 1 0]);
hold on;
% Calcolo soluzione esatta
for j=1:n+2
   for i=1:n+2
      g(i,j)=feval('gfun',x(i),y(j));
   end
end
surf(x,y,g,'FaceColor',[0 0 1])
legend('sol. numerica','sol. esatta');

errore=norm(v-g,'inf')