function w=upwind(f,N,M,c,a,b,t0,tmax)

% dallo script principale vengono passati la velocit 'c' e i passi lungo x
% (N) e i passi temporali (M), oltre alla funzione iniziale (f)

clc;
close all;
t=linspace(t0,tmax,M);
x=linspace(a,b,N);
k=(tmax-t0)/(M-1);
h=(b-a)/(N-1);
w=zeros(length(t),N);
sol=zeros(length(t),N);

%condizioni al contorno
w(:,1)=zeros(1,length(t));        
sol(:,1)=zeros(1,length(t));      

%condizione iniziale
w(1,:)=f(x);                    
sol(1,:)=f(x);

r=c*k/h;

if (abs(c)*k/h)>1
    fprintf('\nCondizione di stabilit NON rispettata\n');
else
for j=1:M-1
   for i=2:N-1
            if c>0
                w(j+1,i) = w(j,i) - r*(w(j,i)-w(j,i-1));
            else
                w(j+1,i) = w(j,i) - r*(w(j,i+1)-w(j,i));
                  
            end
            sol(j+1,i)=f(x(i)-c*t(j));
   end
        plot(x,sol(j,:),'r');   % plot della soluzione esatta
        hold on;
        plot(x,w(j,:),'bo');    % plot della soluzione numerica
        legend('esatta','numerica');
        title('Andamento dell''onda nel tempo')
        fprintf('\nPremere un tasto per visualizzare la situazione all''istante successivo\n');
        pause;
        hold off;
end
figure; surf(w);
figure; surf(sol);
end